Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.gjt.sp.jedit.bsh.org.objectweb.asm
Class CodeWriter

    java.lang.Object
      org.gjt.sp.jedit.bsh.org.objectweb.asm.CodeWriter

All Implemented Interfaces:
  CodeVisitor

    public class CodeWriter

extends java.lang.Object
implements CodeVisitor

A `CodeVisitor` that generates Java bytecode instructions. Each visit method of this class appends the bytecode corresponding to the visited instruction to a byte vector, in the order these methods are called.

Constructor Summary
`protected` | `CodeWriter(ClassWriter cw, boolean computeMaxs)` Constructs a CodeWriter.

Method Summary
`protected byte[]` | `getCode()` Returns the current bytecode of this method.
`protected int` | `getCodeSize()` Returns the current size of the bytecode of this method.
`protected void` | `init(int access, java.lang.String name, java.lang.String desc, java.lang.String[] exceptions)` Initializes this CodeWriter to define the bytecode of the specified method.
`protected int[]` | `resizeInstructions(int[] indexes, int[] sizes, int len)` Resizes the designated instructions, while keeping jump offsets and instruction addresses consistent.
`void` | `visitFieldInsn(int opcode, java.lang.String owner, java.lang.String name, java.lang.String desc)` Visits a field instruction.
`void` | `visitIincInsn(int var, int increment)` Visits an IINC instruction.
`void` | `visitInsn(int opcode)` Visits a zero operand instruction.
`void` | `visitIntInsn(int opcode, int operand)` Visits an instruction with a single int operand.
`void` | `visitJumpInsn(int opcode, Label label)` Visits a jump instruction.
`void` | `visitLabel(Label label)` Visits a label.
`void` | `visitLdcInsn(java.lang.Object cst)` Visits a LDC instruction.
`void` | `visitLineNumber(int line, Label start)` Visits a line number declaration.
`void` | `visitLocalVariable(java.lang.String name, java.lang.String desc, Label start, Label end, int index)` Visits a local variable declaration.
`void` | `visitLookupSwitchInsn(Label dflt, int[] keys, Label[] labels)` Visits a LOOKUPSWITCH instruction.
`void` | `visitMaxs(int maxStack, int maxLocals)` Visits the maximum stack size and the maximum number of local variables of the method.
`void` | `visitMethodInsn(int opcode, java.lang.String owner, java.lang.String name, java.lang.String desc)` Visits a method instruction.
`void` | `visitMultiANewArrayInsn(java.lang.String desc, int dims)` Visits a MULTIANEWARRAY instruction.
`void` | `visitTableSwitchInsn(int min, int max, Label dflt, Label[] labels)` Visits a TABLESWITCH instruction.
`void` | `visitTryCatchBlock(Label start, Label end, Label handler, java.lang.String type)` Visits a try catch block.
`void` | `visitTypeInsn(int opcode, java.lang.String desc)` Visits a type instruction.
`void` | `visitVarInsn(int opcode, int var)` Visits a local variable instruction.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CodeWriter

    protected CodeWriter(ClassWriter cw,
                         boolean computeMaxs)

  Constructs a CodeWriter.

  Parameters:
    `cw` - the class writer in which the method must be added.
    `computeMaxs` - `true` if the maximum stack size and number of local variables must be automatically computed.

Method Detail

### init

    protected void init(int access,
                        java.lang.String name,
                        java.lang.String desc,
                        java.lang.String[] exceptions)

  Initializes this CodeWriter to define the bytecode of the specified method.

  Parameters:
    `access` - the method's access flags (see `Constants`).
    `name` - the method's name.
    `desc` - the method's descriptor (see `Type`).
    `exceptions` - the internal names of the method's exceptions. May be `null`.

### visitInsn

    public void visitInsn(int opcode)

  Description copied from interface: `CodeVisitor`
  Visits a zero operand instruction.

  Specified by:
    `visitInsn` in interface `CodeVisitor`
  Parameters:
    `opcode` - the opcode of the instruction to be visited. This opcode is either NOP, ACONST_NULL, ICONST_M1, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, LCONST_0, LCONST_1, FCONST_0, FCONST_1, FCONST_2, DCONST_0, DCONST_1, IALOAD, LALOAD, FALOAD, DALOAD, AALOAD, BALOAD, CALOAD, SALOAD, IASTORE, LASTORE, FASTORE, DASTORE, AASTORE, BASTORE, CASTORE, SASTORE, POP, POP2, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, SWAP, IADD, LADD, FADD, DADD, ISUB, LSUB, FSUB, DSUB, IMUL, LMUL, FMUL, DMUL, IDIV, LDIV, FDIV, DDIV, IREM, LREM, FREM, DREM, INEG, LNEG, FNEG, DNEG, ISHL, LSHL, ISHR, LSHR, IUSHR, LUSHR, IAND, LAND, IOR, LOR, IXOR, LXOR, I2L, I2F, I2D, L2I, L2F, L2D, F2I, F2L, F2D, D2I, D2L, D2F, I2B, I2C, I2S, LCMP, FCMPL, FCMPG, DCMPL, DCMPG, IRETURN, LRETURN, FRETURN, DRETURN, ARETURN, RETURN, ARRAYLENGTH, ATHROW, MONITORENTER, or MONITOREXIT.

### visitIntInsn

    public void visitIntInsn(int opcode,
                             int operand)

  Description copied from interface: `CodeVisitor`
  Visits an instruction with a single int operand.

  Specified by:
    `visitIntInsn` in interface `CodeVisitor`
  Parameters:
    `opcode` - the opcode of the instruction to be visited. This opcode is either BIPUSH, SIPUSH or NEWARRAY.
    `operand` - the operand of the instruction to be visited.

### visitVarInsn

    public void visitVarInsn(int opcode,
                             int var)

  Description copied from interface: `CodeVisitor`
  Visits a local variable instruction. A local variable instruction is an instruction that loads or stores the value of a local variable.

  Specified by:
    `visitVarInsn` in interface `CodeVisitor`
  Parameters:
    `opcode` - the opcode of the local variable instruction to be visited. This opcode is either ILOAD, LLOAD, FLOAD, DLOAD, ALOAD, ISTORE, LSTORE, FSTORE, DSTORE, ASTORE or RET.
    `var` - the operand of the instruction to be visited. This operand is the index of a local variable.

### visitTypeInsn

    public void visitTypeInsn(int opcode,
                              java.lang.String desc)

  Description copied from interface: `CodeVisitor`
  Visits a type instruction. A type instruction is an instruction that takes a type descriptor as parameter.

  Specified by:
    `visitTypeInsn` in interface `CodeVisitor`
  Parameters:
    `opcode` - the opcode of the type instruction to be visited. This opcode is either NEW, ANEWARRAY, CHECKCAST or INSTANCEOF.
    `desc` - the operand of the instruction to be visited. This operand is must be a fully qualified class name in internal form, or the type descriptor of an array type (see `Type`).

### visitFieldInsn

    public void visitFieldInsn(int opcode,
                               java.lang.String owner,
                               java.lang.String name,
                               java.lang.String desc)

  Description copied from interface: `CodeVisitor`
  Visits a field instruction. A field instruction is an instruction that loads or stores the value of a field of an object.

  Specified by:
    `visitFieldInsn` in interface `CodeVisitor`
  Parameters:
    `opcode` - the opcode of the type instruction to be visited. This opcode is either GETSTATIC, PUTSTATIC, GETFIELD or PUTFIELD.
    `owner` - the internal name of the field's owner class (see `getInternalName`).
    `name` - the field's name.
    `desc` - the field's descriptor (see `Type`).

### visitMethodInsn

    public void visitMethodInsn(int opcode,
                                java.lang.String owner,
                                java.lang.String name,
                                java.lang.String desc)

  Description copied from interface: `CodeVisitor`
  Visits a method instruction. A method instruction is an instruction that invokes a method.

  Specified by:
    `visitMethodInsn` in interface `CodeVisitor`
  Parameters:
    `opcode` - the opcode of the type instruction to be visited. This opcode is either INVOKEVIRTUAL, INVOKESPECIAL, INVOKESTATIC or INVOKEINTERFACE.
    `owner` - the internal name of the method's owner class (see `getInternalName`).
    `name` - the method's name.
    `desc` - the method's descriptor (see `Type`).

### visitJumpInsn

    public void visitJumpInsn(int opcode,
                              Label label)

  Description copied from interface: `CodeVisitor`
  Visits a jump instruction. A jump instruction is an instruction that may jump to another instruction.

  Specified by:
    `visitJumpInsn` in interface `CodeVisitor`
  Parameters:
    `opcode` - the opcode of the type instruction to be visited. This opcode is either IFEQ, IFNE, IFLT, IFGE, IFGT, IFLE, IF_ICMPEQ, IF_ICMPNE, IF_ICMPLT, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ACMPEQ, IF_ACMPNE, GOTO, JSR, IFNULL or IFNONNULL.
    `label` - the operand of the instruction to be visited. This operand is a label that designates the instruction to which the jump instruction may jump.

### visitLabel

    public void visitLabel(Label label)

  Description copied from interface: `CodeVisitor`
  Visits a label. A label designates the instruction that will be visited just after it.

  Specified by:
    `visitLabel` in interface `CodeVisitor`
  Parameters:
    `label` - a `Label` object.

### visitLdcInsn

    public void visitLdcInsn(java.lang.Object cst)

  Description copied from interface: `CodeVisitor`
  Visits a LDC instruction.

  Specified by:
    `visitLdcInsn` in interface `CodeVisitor`
  Parameters:
    `cst` - the constant to be loaded on the stack. This parameter must be a non null `Integer`, a `Float`, a `Long`, a `Double` or a `String`.

### visitIincInsn

    public void visitIincInsn(int var,
                              int increment)

  Description copied from interface: `CodeVisitor`
  Visits an IINC instruction.

  Specified by:
    `visitIincInsn` in interface `CodeVisitor`
  Parameters:
    `var` - index of the local variable to be incremented.
    `increment` - amount to increment the local variable by.

### visitTableSwitchInsn

    public void visitTableSwitchInsn(int min,
                                     int max,
                                     Label dflt,
                                     Label[] labels)

  Description copied from interface: `CodeVisitor`
  Visits a TABLESWITCH instruction.

  Specified by:
    `visitTableSwitchInsn` in interface `CodeVisitor`
  Parameters:
    `min` - the minimum key value.
    `max` - the maximum key value.
    `dflt` - beginning of the default handler block.
    `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `min + i` key.

### visitLookupSwitchInsn

    public void visitLookupSwitchInsn(Label dflt,
                                      int[] keys,
                                      Label[] labels)

  Description copied from interface: `CodeVisitor`
  Visits a LOOKUPSWITCH instruction.

  Specified by:
    `visitLookupSwitchInsn` in interface `CodeVisitor`
  Parameters:
    `dflt` - beginning of the default handler block.
    `keys` - the values of the keys.
    `labels` - beginnings of the handler blocks. `labels[i]` is the beginning of the handler block for the `keys[i]` key.

### visitMultiANewArrayInsn

    public void visitMultiANewArrayInsn(java.lang.String desc,
                                        int dims)

  Description copied from interface: `CodeVisitor`
  Visits a MULTIANEWARRAY instruction.

  Specified by:
    `visitMultiANewArrayInsn` in interface `CodeVisitor`
  Parameters:
    `desc` - an array type descriptor (see `Type`).
    `dims` - number of dimensions of the array to allocate.

### visitTryCatchBlock

    public void visitTryCatchBlock(Label start,
                                   Label end,
                                   Label handler,
                                   java.lang.String type)

  Description copied from interface: `CodeVisitor`
  Visits a try catch block.

  Specified by:
    `visitTryCatchBlock` in interface `CodeVisitor`
  Parameters:
    `start` - beginning of the exception handler's scope (inclusive).
    `end` - end of the exception handler's scope (exclusive).
    `handler` - beginning of the exception handler's code.
    `type` - internal name of the type of exceptions handled by the handler, or `null` to catch any exceptions (for "finally" blocks).

### visitMaxs

    public void visitMaxs(int maxStack,
                          int maxLocals)

  Description copied from interface: `CodeVisitor`
  Visits the maximum stack size and the maximum number of local variables of the method.

  Specified by:
    `visitMaxs` in interface `CodeVisitor`
  Parameters:
    `maxStack` - maximum stack size of the method.
    `maxLocals` - maximum number of local variables for the method.

### visitLocalVariable

    public void visitLocalVariable(java.lang.String name,
                                   java.lang.String desc,
                                   Label start,
                                   Label end,
                                   int index)

  Description copied from interface: `CodeVisitor`
  Visits a local variable declaration.

  Specified by:
    `visitLocalVariable` in interface `CodeVisitor`
  Parameters:
    `name` - the name of a local variable.
    `desc` - the type descriptor of this local variable.
    `start` - the first instruction corresponding to the scope of this local variable (inclusive).
    `end` - the last instruction corresponding to the scope of this local variable (exclusive).
    `index` - the local variable's index.

### visitLineNumber

    public void visitLineNumber(int line,
                                Label start)

  Description copied from interface: `CodeVisitor`
  Visits a line number declaration.

  Specified by:
    `visitLineNumber` in interface `CodeVisitor`
  Parameters:
    `line` - a line number. This number refers to the source file from which the class was compiled.
    `start` - the first instruction corresponding to this line number.

### resizeInstructions

    protected int[] resizeInstructions(int[] indexes,
                                       int[] sizes,
                                       int len)

  Resizes the designated instructions, while keeping jump offsets and instruction addresses consistent. This may require to resize other existing instructions, or even to introduce new instructions: for example, increasing the size of an instruction by 2 at the middle of a method can increases the offset of an IFEQ instruction from 32766 to 32768, in which case IFEQ 32766 must be replaced with IFNEQ 8 GOTO_W 32765. This, in turn, may require to increase the size of another jump instruction, and so on... All these operations are handled automatically by this method.

  This method must be called after all the method that is being built has been visited. In particular, the `Label` objects used to construct the method are no longer valid after this method has been called.

  Parameters:
    `indexes` - current positions of the instructions to be resized. Each instruction must be designated by the index of its last byte, plus one (or, in other words, by the index of the first byte of the next instruction).
    `sizes` - the number of bytes to be added to the above instructions. More precisely, for each i < `len`, `sizes`[i] bytes will be added at the end of the instruction designated by `indexes`[i] or, if `sizes`[i] is negative, the last |`sizes[i]`| bytes of the instruction will be removed (the instruction size must not become negative or null). The gaps introduced by this method must be filled in "manually" in the array returned by the `getCode` method.
    `len` - the number of instruction to be resized. Must be smaller than or equal to `indexes`.length and `sizes`.length.
  Returns:
    the `indexes` array, which now contains the new positions of the resized instructions (designated as above).

### getCodeSize

    protected int getCodeSize()

  Returns the current size of the bytecode of this method. This size just includes the size of the bytecode instructions: it does not include the size of the Exceptions, LocalVariableTable, LineNumberTable, Synthetic and Deprecated attributes, if present.

  Returns:
    the current size of the bytecode of this method.

### getCode

    protected byte[] getCode()

  Returns the current bytecode of this method. This bytecode only contains the instructions: it does not include the Exceptions, LocalVariableTable, LineNumberTable, Synthetic and Deprecated attributes, if present.

  Returns:
    the current bytecode of this method. The bytecode is contained between the index 0 (inclusive) and the index `getCodeSize` (exclusive).

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD